# rsvpmaker
RSVPMaker is an event scheduling and RSVP tracking plugin for WordPress. Use it to:

* Schedule and promote events of all sorts: conferences, classes, seminars, speaking events, parties and weddings are a few common uses.
* Register attendees, prompting them to enter whatever information you need, including the names of guests.
* Collect money using PayPal or Stripe.
* Promote your event on social media and send out email list invitations using the integration with MailChimp. Can also be used to for email newsletters based on blog posts or event roundups from your website.
* Create webinars and other online events leveraging free resources like the YouTube Live service.
* Use the Limited Time Content Gutenberg block -- a wrapper block that can include paragraphs, images, and other content -- to set a start and/or end time for the display of content. Useful for promoting events and limited time pricing on your home page or in the body of a blog post, without looking foolish if you forget to take down those promotions.

https://youtu.be/gt6fE07a8bc

RSVPMaker is free and open source, with no upsell to a premium version. We occasionally create custom features on contract, but where possible those enhancements are folded back into the coe plugin code. RSVPMaker is also developer friendly, allowing you to build event-centric applications on top of it.

Creating and Managing Events

RSVPMaker events are created and edited just like blog posts in the WordPress editor, with the addition of parameters like event date (so the items can be listed chronologically and displayed on a calendar grid). Supports the Gutenberg editor as well as the classic WordPress editor.

You can use RSVPMaker for event announcements, or turn on the Collect RSVPs function and set additional options for sending email notifications, customizing confirmation and reminder messages, and setting a price or prices if you will be requesting online payments via PayPal.

RSVP reports can be viewed on the administrator's dashboard or downloaded as spreadsheets.

If you hold events on a recurring schedule, such as First Monday or Every Friday, you can define a template with the boilerplate details and quickly generate multiple entries that follow that schedule. Individual event posts can still be customized. For example, you might book a series of monthly events for the year and add the names of speakers or agenda details as you go along.

In addition to being useful for event invitations, the MailChimp integration can be used to generate newsletters incorporating roundups of upcoming events and recent blog posts.

[__RSVPMaker.com__](http://www.rsvpmaker.com/)
[RSVPMaker on WordPress](https://wordpress.org/plugins/rsvpmaker)
